=== modified file 'debian/patches/series'
--- debian/patches/series	2012-11-26 07:13:04 +0000
+++ debian/patches/series	2012-12-07 09:46:56 +0000
@@ -1,6 +1,5 @@
 ubuntu-config.patch
 ccp_plugin.patch
-workaround_broken_drivers.patch
 ccsm_remove_redundant_sliders.patch
 ccsm_add_first_run_warning.patch
 ccsm_disable_unity_checkbox.patch

=== removed file 'debian/patches/workaround_broken_drivers.patch'
--- debian/patches/workaround_broken_drivers.patch	2012-08-24 13:41:00 +0000
+++ debian/patches/workaround_broken_drivers.patch	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-Index: ubuntu_quantal_trunk/plugins/opengl/src/screen.cpp
-===================================================================
---- ubuntu_quantal_trunk.orig/plugins/opengl/src/screen.cpp	2012-08-22 18:07:44.344116000 +0800
-+++ ubuntu_quantal_trunk/plugins/opengl/src/screen.cpp	2012-08-22 18:09:37.269159461 +0800
-@@ -37,6 +37,21 @@
- #include <dlfcn.h>
- #include <math.h>
- 
-+class DetectionWorkaround
-+{
-+    public:
-+
-+        DetectionWorkaround ()
-+        {
-+            program_invocation_short_name[0] = 'C';
-+        }
-+        ~DetectionWorkaround ()
-+        {
-+            program_invocation_short_name[0] = 'c';
-+        }
-+};
-+
-+
- using namespace compiz::opengl;
- 
- namespace GL {
-@@ -274,6 +289,8 @@
- bool
- GLScreen::glInitContext (XVisualInfo *visinfo)
- {
-+    DetectionWorkaround workaround;
-+
-     #ifdef USE_GLES
-     Display             *xdpy;
-     Window               overlay;
-@@ -814,6 +831,8 @@
-     PluginClassHandler<GLScreen, CompScreen, COMPIZ_OPENGL_ABI> (s),
-     priv (new PrivateGLScreen (this))
- {
-+    DetectionWorkaround workaround;
-+
-     XVisualInfo		 *visinfo = NULL;
- #ifndef USE_GLES
-     Display		 *dpy = s->dpy ();

=== modified file 'plugins/opengl/src/screen.cpp'
--- plugins/opengl/src/screen.cpp	2012-12-05 12:53:59 +0000
+++ plugins/opengl/src/screen.cpp	2012-12-07 09:46:56 +0000
@@ -42,6 +42,29 @@
 
 template class WrapableInterface<GLScreen, GLScreenInterface>;
 
+#ifndef USE_GLES
+/*
+ * Historically most versions of fglrx have contained a nasty hack that checks
+ * if argv[0] == "compiz", and downgrades OpenGL features including dropping
+ * GLSL support (hides GL_ARB_shading_language_100). (LP #1026920)
+ * This hack in fglrx is misguided and I'm told AMD have or will remove
+ * it soon. In the mean time, modify argv[0] so it's not triggered...
+ */
+class DetectionWorkaround
+{
+    public:
+        DetectionWorkaround ()
+        {
+            program_invocation_short_name[0] = 'C';
+        }
+        ~DetectionWorkaround ()
+        {
+            program_invocation_short_name[0] = 'c';
+        }
+};
+#endif
+
+
 using namespace compiz::opengl;
 
 namespace GL {
@@ -337,6 +360,10 @@
 bool
 GLScreen::glInitContext (XVisualInfo *visinfo)
 {
+#ifndef USE_GLES
+    DetectionWorkaround workaround;
+#endif
+
     #ifdef USE_GLES
     Display             *xdpy;
     Window               overlay;
@@ -773,15 +800,6 @@
 
     priv->updateRenderMode ();
 
-    /*
-     * !!! WARNING for users of the ATI/AMD fglrx driver !!!
-     *
-     * fglrx contains a hack which hides GL_ARB_shading_language_100 if
-     * your argv[0]=="compiz" for stupid historical reasons, so you won't
-     * get shader support by default when using fglrx.
-     *
-     * Workaround: Rename or link your "compiz" binary to "Compiz".
-     */
     if (strstr (glExtensions, "GL_ARB_fragment_shader") &&
         strstr (glExtensions, "GL_ARB_vertex_shader") &&
 	strstr (glExtensions, "GL_ARB_shader_objects") &&
@@ -892,6 +910,10 @@
     PluginClassHandler<GLScreen, CompScreen, COMPIZ_OPENGL_ABI> (s),
     priv (new PrivateGLScreen (this))
 {
+#ifndef USE_GLES
+    DetectionWorkaround workaround;
+#endif
+
     XVisualInfo		 *visinfo = NULL;
 #ifndef USE_GLES
     Display		 *dpy = s->dpy ();

